VERSION 5.00
Begin VB.Form StarfieldExamples 
   BackColor       =   &H80000008&
   ClientHeight    =   7785
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   10590
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   519
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   706
   StartUpPosition =   3  'Windows Default
   WindowState     =   2  'Maximized
   Begin VB.PictureBox Background 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   7815
      Left            =   0
      ScaleHeight     =   521
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   705
      TabIndex        =   0
      Top             =   0
      Width           =   10575
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Options"
      Begin VB.Menu mnuBlackhole 
         Caption         =   "Black hole"
      End
      Begin VB.Menu mnuSnow 
         Caption         =   "Snow"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuStars 
         Caption         =   "Stars"
      End
      Begin VB.Menu mnuline1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuRun 
         Caption         =   "Run"
      End
      Begin VB.Menu mnuline2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuQuit 
         Caption         =   "Quit"
      End
   End
End
Attribute VB_Name = "StarfieldExamples"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'turn off control box on the form settings for full screen


Dim Quit As Byte
Dim i As Integer
Dim ActionMode As String
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long


Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long


Private Sub Background_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    SpecialEffectX = x 'tempInt
    SpecialEffectY = Y 'tempInt
    
End Sub

Private Sub Form_Activate()
  'ShowCursor False
  Dim MyValue As Byte, x
  Randomize
  MyValue = Int((3 * Rnd) + 1)
  Select Case MyValue
    Case 1
    mnuSnow_Click
    Case 2
    mnuStars_Click
    Case 3
    mnuBlackhole_Click
  End Select
  mnuRun_Click

  Do While ActionMode = "OK" Or ActionMode = "Running"
    Do While ActionMode = "Running"
      Background = LoadPicture ' clear the background
      For i = 0 To StarCount
        NextStarPosition i, Background.Height, Background.Width
        SetPixel Background.hdc, Star(i).StarX, Star(i).StarY + Star(i).SpeedY, QBColor(Star(i).StarColor)
      Next i
      Background.Refresh
      DoEvents
    Loop
    DoEvents
  Loop
ShowCursor True
  Unload Me
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
  ActionMode = "Out of here"
  
End Sub
 
Private Sub Form_Load()
  SpecialEffectX = StarfieldExamples.ScaleWidth / 2
  SpecialEffectY = StarfieldExamples.ScaleHeight / 2
End Sub



Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  ActionMode = "Out of here"
End Sub

Private Sub Form_Resize()
Background.Height = StarfieldExamples.ScaleHeight
Background.Width = StarfieldExamples.ScaleWidth
StarSetup Background.Height, Background.Width
End Sub

Private Sub mnuBlackhole_Click()
  Status = "Black Hole"
  StarSetup Background.Height, Background.Width
  CaptionStatus
  mnuBlackhole.Checked = True
End Sub

Private Sub mnuQuit_Click()
  ActionMode = "Out of here"
End Sub

Private Sub mnuRun_Click()

  If mnuRun.Caption = "Run" Then
    StarCount = 0
    ReDimStars 250
    StarSetup Background.Height, Background.Width
    mnuRun.Caption = "Stop"
    ActionMode = "Running"
    mnuQuit.Enabled = False
  Else
    ActionMode = "OK"
    mnuRun.Caption = "Run"
    mnuQuit.Enabled = True
  End If
End Sub

Private Sub mnuSnow_Click()
  Status = "Snow"
  StarSetup Background.Height, Background.Width
  CaptionStatus
  mnuSnow.Checked = True
End Sub

Private Sub mnuStars_Click()
  Status = "Stars"
  StarSetup Background.Height, Background.Width
  CaptionStatus
  mnuStars.Checked = True
End Sub

Sub CaptionStatus()
  mnuSnow.Checked = False
  mnuStars.Checked = False
  mnuBlackhole.Checked = False
End Sub
